//***************************************************************************
//
//  Copyright (c) 1999 - 2006 Intel Corporation
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.
//
//***************************************************************************

/**
  @file U3DHeaders.h

      This header defines the ... functionality.

  @note
*/


#ifndef U3DHeaders_H
#define U3DHeaders_H


//***************************************************************************
//  Includes
//***************************************************************************

#include "IFXString.h"
#include "IFXCoreCIDs.h"
#include "IFXAutoRelease.h"

#include "IFXSceneGraph.h"
#include "IFXLight.h"
#include "IFXMaterialResource.h"
#include "IFXModel.h"
#include "IFXModifier.h"
#include "IFXNode.h"
#include "IFXShader.h"
#include "IFXShaderLitTexture.h"
#include "IFXView.h"
#include "IFXPalette.h"
#include "IFXMatrix4x4.h"

#include "IFXAnimationModifier.h"
#include "IFXBoneWeightsModifier.h"
#include "IFXSkeleton.h"

#include "IFXMotionResource.h"
#include "IFXMixerConstruct.h"

#include "IFXImportingCIDs.h"
#include "IFXExportingCIDs.h"

#include "IFXScheduler.h"

#include "IFXAuthorGeomCompiler.h"

#include "IFXSubdivModifier.h"
#include "IFXCLODModifier.h"
#include "IFXShadingModifier.h"
#include "IFXGlyph2DModifier.h"
#include "IFXGlyphCommandList.h"

#include "IFXAuthorMesh.h"
#include "IFXAuthorMeshScrub.h"
#include "IFXAuthorLineSet.h"
#include "IFXAuthorLineSetResource.h"
#include "IFXAuthorPointSet.h"
#include "IFXAuthorPointSetResource.h"

#include "IFXModifierChain.h"

#include "IFXSimulationTask.h"

#include "IFXCLODManagerInterface.h"
#include "IFXNeighborResControllerIntfc.h"

#include "IFXImageCodec.h"
#include "IFXLoadManager.h"
#include "IFXWriteManager.h"
#include "IFXBoundSphereDataElement.h"
#include "IFXDids.h"
#include "IFXStdio.h"

//***************************************************************************
//  Defines
//***************************************************************************


//***************************************************************************
//  Constants
//***************************************************************************


//***************************************************************************
//  Enumerations
//***************************************************************************


//***************************************************************************
//  Classes, structures and types
//***************************************************************************


//***************************************************************************
//  Inline functions
//***************************************************************************


//***************************************************************************
//  Global function prototypes
//***************************************************************************


//***************************************************************************
//  Global data
//***************************************************************************


#endif
